#!/bin/sh

# Copyright (C) 2023  Braiins Systems s.r.o.
#
# This file is part of Braiins Open-Source Initiative (BOSI).
#
# BOSI is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <https://www.gnu.org/licenses/>.
#
# Please, keep in mind that we may also license BOSI or any part thereof
# under a proprietary license. For more information on the terms and conditions
# of such proprietary license or if you have any other questions, please
# contact us at opensource@braiins.com.

set -e

# The original directory from which the packages are expected to be installed
COMPAT_UPGRADE_DIR="/tmp/upgrade"

packages_mask="./packages/*.ipk"

# Do not quote $packages_mask or it will not be able to scan dir
if ls $packages_mask 2>/dev/null 1>&2; then
    echo "Packages to install: "
    ls $packages_mask

    # NOTE: The package contains the following script and that's the reason why
    # the current directory must be changed:
    #
    # Do not run bosminer reload when the package is installed in stage 3
    # ! begins_with "/tmp/upgrade" "$PWD" && /etc/init.d/bosminer reload
    mkdir -p "$COMPAT_UPGRADE_DIR"
    mv $packages_mask "$COMPAT_UPGRADE_DIR"
    cd "$COMPAT_UPGRADE_DIR"

    if /bin/opkg install *.ipk; then
        echo "Packages installed successfully"
    else
        echo "Packages failed to install"
    fi

    cd -
    rm -rf "$COMPAT_UPGRADE_DIR"
fi

exit 0
